当前位置: 首页 > 工具软件 > Gaunt > 使用案例 >

Marvolo Gaunt's Ring ---CodeForces - 855B(思维题)

闽康安
2023-12-01

题目链接:http://codeforces.com/problemset/problem/855/B

 

Marvolo Gaunt's Ring

Professor Dumbledore is helping Harry destroy the Horcruxes. He went to Gaunt Shack as he suspected a Horcrux to be present there. He saw Marvolo Gaunt's Ring and identified it as a Horcrux. Although he destroyed it, he is still affected by its curse. Professor Snape is helping Dumbledore remove the curse. For this, he wants to give Dumbledore exactly x drops of the potion he made.

Value of x is calculated as maximum of p·ai + q·aj + r·ak for given p, q, r and array a1, a2, ... an such that 1 ≤ i ≤ j ≤ k ≤ n. Help Snape find the value of x. Do note that the value of x may be negative.

Input

First line of input contains 4 integers n, p, q, r ( - 109 ≤ p, q, r ≤ 109, 1 ≤ n ≤ 105).

Next line of input contains n space separated integers a1, a2, ... an ( - 109 ≤ ai ≤ 109).

Output

Output a single integer the maximum value of p·ai + q·aj + r·ak that can be obtained provided 1 ≤ i ≤ j ≤ k ≤ n.

Examples

Input

5 1 2 3
1 2 3 4 5

Output

30

Input

5 1 2 -3
-1 -2 -3 -4 -5

Output

12

Note

In the first sample case, we can take i = j = k = 5, thus making the answer as 1·5 + 2·5 + 3·5 = 30.

In second sample case, selecting i = j = 1 and k = 5 gives the answer 12.

 

看到这个题我的第一个想法是这么简单的题,直接暴力上呗,直接就WA了。。。这就是一个简单题嘛   woc

知道很久以后才发现这还是一个简单题,但是有坑,一定要留意    1 ≤ i ≤ j ≤ k ≤ n.   这个条件!!!

据说这个题有五六种做法,什么线段树啦  乱七八糟的,但是我不会。。。。只想到一个最简单的 

下面的代码有两种做法,但是思想是完全一样的。只要注意了顺序,一切ojbk

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<string>
#include<cmath>
#define ll long long
#define mem(a,b) memset(a,b,sizeof(a))
using namespace std;
const ll inf=0x3f3f3f3f3f3f3f3f;
const ll mm=1e6+10;
ll a[mm];

int main()
{
	ll n;
	ll pp[9];
	scanf("%lld",&n);
	for(ll i=1;i<=3;i++)
		scanf("%lld",&pp[i]);
//暴力死在了这里~~~			
//	for(ll i=1;i<=n;i++){
//		scanf("%lld",&a[i]);
//		
//		x=max(x,pp[1]*a[i]);
//		y=max(y,pp[2]*a[i]);
//		z=max(z,pp[3]*a[i]);
//	}
//	res=x+y+z;
//	printf("%lld",res); 
	ll res=0;
	ll x=-inf,y=-inf,z=-inf;
	for(ll i=1;i<=n;i++){
		scanf("%lld",&a[i]);
		
		x=max(x,pp[1]*a[i]);
		y=max(y,x+pp[2]*a[i]);
		z=max(z,y+pp[3]*a[i]);
	}
	printf("%lld",z);
	return 0;
}

//下面是另一种做法  dp	
/*—————————————————————————

ll dp[3][mm];//dp[i][j]表示前i个最大值之和 
ll a[mm];
int main()
{
	ll p,q,r,n;
    cin>>n>>p>>q>>r;
    for(ll i=1;i<=n;i++)
        cin>>a[i];
    
    dp[0][0]=-inf;
    dp[1][0]=-inf;
    dp[2][0]=-inf;
    for(ll i=1;i<=n;i++){
        dp[0][i]=max(dp[0][i-1],p*a[i]);
        dp[1][i]=max(dp[1][i-1],dp[0][i]+q*a[i]);
        dp[2][i]=max(dp[2][i-1],dp[1][i]+r*a[i]);
    }
    cout<<dp[2][n]<<endl;
	return 0;
}
*/	
 类似资料: